<template>
    <div
        v-if="shop"
        class="page-container"
    >
        <div class="video-button-container">
            <div
                v-if="balance && isWix && showEmailPlan_B"
                class="info-block__container"
            >
                <div class="info-block">
                    <div class="d-flex align-items-center">
                        <div class="info-block__text">
                            Email sent:
                        </div>
                        <div class="info-block__count">
                            {{ balance.emailSent }}/{{ balance.emailCount }}
                        </div>
                    </div>
                    <b-button
                        class="btn info-block__btn"
                        variant="primary"
                        @click="showModalAddEmailCredits = true"
                    >
                        Add email credits
                    </b-button> 
                </div>
            </div>
            <VideoButton :source="'https://carti.crisp.help/en/article/email-campaigns-1152uka/reader'" />
        </div>
        <div class="row">
            <EmailCard
                v-for="(card, index) in campaignsCards"
                :key="index"
                class="col-lg-4"
                :loader="loading"
                :cart-data="card"
            />
        </div>
        <CampaignsContent
            :draft-page="draftsPage"
            :drafts="drafts"
            :campaigns="campaigns"
            :schedule-page="schedulesPage"
            :history-page="historiesPage"
            :histories="histories"
            @getDrafts="getDrafts"
            @getCampaigns="getCampaigns"
            @getHistories="getHistories"
        />
        <AddEmailCredits
            :show="showModalAddEmailCredits"
            @close="showModalAddEmailCredits = false"
            @submited="showModalAddEmailCredits = false, updBalance()"
        />
    </div>
</template>

<script>
import VideoButton from "@/components/header/VideoButton";
import CampaignsContent from "@/components/email/campaigns/CampaignsContent";
import EmailCard from "@/components/email/abandoned-cards/EmailCard";
import campaigns from "@/mixins/email/campaigns.service";
import currencies from "@/data/currencies.json";
import shop from '@/mixins/shop.service'
import AddEmailCredits from '@/components/email/AddEmailCredits'
import abTesting from '@/mixins/ab-testing'


export default {
    name: "EmailCampaigns",
    components: {EmailCard, CampaignsContent, VideoButton, AddEmailCredits},
    mixins: [campaigns, shop, abTesting],
    data: () => ({
        campaignsCards: [
            {
                title: 'Revenue Recovered',
                icon: 'fa fa-window-maximize',
                salesCount: '0',
                salesTitle: 'Sales'
            },
            {
                title: 'Subscribers',
                icon: 'fa fa-users',
                salesCount: '0',
                salesTitle: 'Quantity'
            },
            {
                title: 'Orders Recovered',
                icon: 'fa fa-cube',
                salesCount: '0',
                salesTitle: 'Quantity'
            }
        ],
        shop: null,
        carts: null,
        loading: true,
        drafts: null,
        currencies: currencies,
        campaigns: null,
        histories: null,
        showEmailPlan_B: false,
        showModalAddEmailCredits: false,
        draftsPage: {
            number: 1
        },
        schedulesPage: {
            number: 1
        },
        historiesPage: {
            number: 1
        },
        balance: null,
    }),
    computed: {
        getCurrencySign() {
            if (!this.currencies)
                return {
                    symbol: this.shop?.payment_currency
                };
            return this.currencies[this.shop.payment_currency];
        },
        isWix() {
            return this.$cookies.get('platform') == 'wix'
        }
    },
    created() {
        this.loadShop()
        this.startABTesting()
        if(this.isWix) this.updBalance()
    },
    mounted() {
        this.getCampaignsCarts()
        this.getDrafts()
        this.getCampaigns()
        this.getHistories()
    },
    methods: {
        async updBalance() {
            this.balance = await this.getBalance()
        },
        async  loadShop() {
            this.shop = await this.getShop()
        },
        getCampaignsCarts() {
            this.carts = null
            this.getCarts().then(response => (this.carts = response.data)).then(() => {
                this.campaignsCards = [
                    {
                        title: 'Revenue Recovered',
                        icon: 'fa fa-window-maximize',
                        salesCount: this.getCurrencySign.symbol_native + this.carts.total_revenue,
                        salesTitle: 'Sales'
                    },
                    {
                        title: 'Subscribers',
                        icon: 'fa fa-users',
                        salesCount: this.carts.total_subscribers,
                        salesTitle: 'Quantity'
                    },
                    {
                        title: 'Orders Recovered',
                        icon: 'fa fa-cube',
                        salesCount: this.carts.total_orders,
                        salesTitle: 'Quantity'
                    }
                ]
                this.loading = false
            }).catch(error => {
                console.log(error)
            });
        },
        getDrafts(pageNum = 1) {
            this.draftsPage.number = pageNum
            this.getAllDrafts(pageNum).then(response => (this.drafts = response.data)).catch(error => {
                console.log(error)
            });

        },
        getCampaigns(pageNum = 1) {
            this.schedulesPage = pageNum
            this.getAllCampaigns(pageNum).then(response => (this.campaigns = response.data)).catch(error => {
                console.log(error)
            });
        },
        getHistories(pageNum = 1) {
            this.historiesPage = pageNum
            this.getAllHistories(pageNum).then(response => (this.histories = response.data)).catch(error => {
                console.log(error)
            });
        }
    }
}
</script>

<style scoped lang="scss">

.my-icon {
    color: white;
    margin-right: 8px;
    font-size: 17px;
}

</style>
